/*----------------------------------------------------------------------------
 *                  DMA𗘗pLCD_CNghCuiSTM32F103VET6:12MHz*6)
 *                                                      2010.12.28
 *                                                       H.GURITA
 *----------------------------------------------------------------------------*/

#include <stm32f10x_lib.h>
#include "STM32_Init.h"

unsigned int ROM_ADRESS = 0x08010000;
//LCD ADRESS = 0x68000000
unsigned int D_Line, D_Line2;
unsigned short DUMMY = 0;
unsigned short PIC3[19200];
unsigned int T_Flag = 0;
unsigned int RAM_Flag = 0;

// ******************VA|[g̐ݒigpj***************************************
//UART
void putc_COM1(unsigned char ch)
{   while((USART1->SR & 0x00000080) == 0){ }// TXE ?
    USART1->DR = ((unsigned long)ch & 0x000000FF);// 8bit only
}

unsigned char getc_COM1(void)
{   while((USART1->SR & 0x00000020) == 0){ }// RXNE ?
    return((unsigned char)(USART1->DR & 0x000000FF));
}

//*******************ԑ҂֐************************************************************
// Wait(1200)100sec
void Wait(unsigned long i)
{   while( i != 0)
    {  i--;
    }
}

//*******************DAM`lݒ*********************************************************
// DMA initialize
void DMA_IR_Init(void)
{   NVIC->ISER[0]  = 0x00000800;//0b0000 0000 0000 0000 0000 1000 0000 0000 enable interrupt DMA1-1
    NVIC->ISER[0]  = 0x00001000;// enable interrupt DMA1-2
    NVIC->ISER[0]  = 0x00002000;// enable interrupt DMA1-3 
    NVIC->ISER[0]  = 0x00004000;// enable interrupt DMA1-4
    NVIC->ISER[0]  = 0x00008000;// enable interrupt DMA1-5  
    NVIC->ISER[0]  = 0x00010000;//DMA1-6
    RCC->AHBENR |= 0x00000001;// clock for DMA
}
//DMA 1 start
void DMA_CH_Init(void)
{   D_Line = 0;
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    GPIOB->BSRR = 0x00010000;//VSYNC(PB0) OFF 0000 0000 0000 0001
    GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
    DMA1_Channel1->CCR  &= 0xFFFFFFFE;//DMA stop
    DMA1_Channel1->CMAR  = (unsigned long)&DUMMY;//dummy read
    DMA1_Channel1->CPAR  = 0x68000000;
    DMA1_Channel1->CNDTR = 4 * 300;
    DMA1_Channel1->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
}

//DMA 2 start
void DMAChannel1_IRQHandler(void)
{   GPIOB->BSRR = 0x00000001;//VSYNC(PB0) ON 0000 0000 0000 0001
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    DMA1_Channel2->CCR  &= 0xFFFFFFFE;//DMA stop
    DMA1_Channel2->CMAR  = (unsigned long)&DUMMY;//dummy read
    DMA1_Channel2->CPAR  = 0x68000000;
    DMA1_Channel2->CNDTR = 8 * 300;
    DMA1_Channel2->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
}

//DMA 3 start
void DMAChannel2_IRQHandler(void)
{   GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    DMA1_Channel3->CCR  &= 0xFFFFFFFE;//DMA stop
    DMA1_Channel3->CMAR  = (unsigned long)&DUMMY;//dummy read
    DMA1_Channel3->CPAR  = 0x68000000;
    DMA1_Channel3->CNDTR = 60;
    DMA1_Channel3->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
}

//DMA 4 start
void DMAChannel3_IRQHandler(void)
{   GPIOB->BSRR = 0x00000040;//VDEN(PB6) ON 0000 0000 0100 0000
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    DMA1_Channel4->CCR  &= 0xFFFFFFFE;//DMA stop
    DMA1_Channel4->CMAR  = ROM_ADRESS + D_Line * 240 * 2;
    D_Line++;
    DMA1_Channel4->CPAR  = 0x68000000;
    DMA1_Channel4->CNDTR = 240;
    DMA1_Channel4->CCR   = 0x00006593;//0b0000 0000 0000 0000 0110 0101 1001 0011 MINC
}

//DMA 3 or 5
void DMAChannel4_IRQHandler(void)
{   DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    if(D_Line <= 240)//ROMGA̕`
    {   GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
        DMA1_Channel3->CCR  &= 0xFFFFFFFE;//DMA stop
        DMA1_Channel3->CMAR  = (unsigned long)&DUMMY;//dummy read
        DMA1_Channel3->CPAR  = 0x68000000;
        DMA1_Channel3->CNDTR = 60;
        DMA1_Channel3->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
    }
    else if(D_Line <= 320)//ROM܂RAMGA̕`
    {   if(RAM_Flag == 1)//RAM
        {   GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
            DMA1_Channel6->CCR  &= 0xFFFFFFFE;//DMA stop
            DMA1_Channel6->CMAR  = (unsigned long)&DUMMY;//dummy read
            DMA1_Channel6->CPAR  = 0x68000000;
            DMA1_Channel6->CNDTR = 60;
            DMA1_Channel6->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
        }
        else//ROM
        {   GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
            DMA1_Channel3->CCR  &= 0xFFFFFFFE;//DMA stop
            DMA1_Channel3->CMAR  = (unsigned long)&DUMMY;//dummy read
            DMA1_Channel3->CPAR  = 0x68000000;
            DMA1_Channel3->CNDTR = 60;
            DMA1_Channel3->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
        }
    }
    else//tg|[`
    {   GPIOB->BSRR = 0x00400000;//VDEN(PB6) OFF 0000 0000 0100 0000
        DMA1_Channel5->CCR  &= 0xFFFFFFFE;//DMA stop
        DMA1_Channel5->CMAR  = (unsigned long)&DUMMY;//dummy read
        DMA1_Channel5->CPAR  = 0x68000000;
        DMA1_Channel5->CNDTR = 2 * 300;
        DMA1_Channel5->CCR   = 0x00006513;//0b0000 0000 0000 0000 0110 0101 0001 0011
    }
}

//DMA 1 restart
void DMAChannel5_IRQHandler(void)
{   D_Line = 0; D_Line2 = 0;
    GPIOB->BSRR = 0x00010000;//VSYNC(PB0) OFF 0000 0000 0000 0001
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
}

//RAMGA̕`̂߂ɒǉDMA
void DMAChannel6_IRQHandler(void)
{   GPIOB->BSRR = 0x00000040;//VDEN(PB6) ON 0000 0000 0100 0000
    DMA1->IFCR = 0x0FFFFFFF;//DMA Flag all clear
    DMA1_Channel4->CCR  &= 0xFFFFFFFE;//DMA stop
    DMA1_Channel4->CMAR  = (unsigned long)&PIC3 + D_Line2 * 240 * 2;
    D_Line++; D_Line2++;
    DMA1_Channel4->CPAR  = 0x68000000;
    DMA1_Channel4->CNDTR = 240;
    DMA1_Channel4->CCR   = 0x00006593;//0b0000 0000 0000 0000 0110 0101 1001 0011 MINC
}

// **********************DAMNp^C}[it[[gpj*********************************
// timer4
void TIM4_IRQHandler(void)
{   if((TIM4->SR & 0x00000001) != 0)
    {   TIM4->SR     &= 0xFFFFFFFE;
        if((GPIOB->IDR & 0x00008000) == 0) ROM_ADRESS = 0x08040000;//SW2
        else                               ROM_ADRESS = 0x08010000;

        if((GPIOA->IDR & 0x00000001) == 0) RAM_Flag = 0;//SW1
        else                               RAM_Flag = 1;

        if(T_Flag == 1)  DMA_CH_Init();
    }
}

// ***********************LCDW[ݒpSPȈ*******************************************
void SDI_Set(int b)
{   if(b == 0) GPIOB->BSRR = 0x00020000;//SDI(PB1) OFF 0000 0000 0000 0010
    else 	   GPIOB->BSRR = 0x00000002;//SDI(PB1) ON  0000 0000 0000 0010
}

void SCLK_Set(int b)
{   if(b == 0) GPIOB->BSRR = 0x00200000;//SDI(PB5) OFF 0000 0000 0010 0000
    else 	   GPIOB->BSRR = 0x00000020;//SDI(PB5) ON  0000 0000 0010 0000
}

void SCS_Set(int b)
{   if(b == 0) GPIOB->BSRR = 0x00800000;//SDI(PB7) OFF 0000 0000 1000 0000
    else 	   GPIOB->BSRR = 0x00000080;//SDI(PB7) ON  0000 0000 1000 0000
}

void LCD_Reg_Set(unsigned int data, int bit)
{   int i;
    SCLK_Set(0);
    SCS_Set(0);Wait(25);
    for(i = 1; i <= bit; i++)
    {   SDI_Set((data >> (bit - i)) & 0x00000001);
        Wait(25);
	    SCLK_Set(1);
	    Wait(25);
        SCLK_Set(0);
    }
    Wait(25);SCS_Set(1);
}

// **********************LCDW[R}h*************************************************
void GLCD_Init(void)
{   GPIOB->BSRR = 0x01000000;//RESET(PB8) OFF 0000 0001 0000 0000
    Wait(100);
    GPIOB->BSRR = 0x00000100;//RESET(PB8) ON 0000 0001 0000 0000
    Wait(1000);
    LCD_Reg_Set(0x007080, 24);
    Wait(115 * 1200);
    LCD_Reg_Set(0x007A01, 24);
    LCD_Reg_Set(0x0070C8, 24);
    LCD_Reg_Set(0x00A100, 24);
    LCD_Reg_Set(0x00A000, 24);
    LCD_Reg_Set(0x0072A3, 24);
    LCD_Reg_Set(0x007304, 24);
    LCD_Reg_Set(0x007546, 24);
    LCD_Reg_Set(0x007623, 24);
    LCD_Reg_Set(0x007708, 24);
    LCD_Reg_Set(0x007808, 24);
    LCD_Reg_Set(0x007900, 24);
    LCD_Reg_Set(0x007FF0, 24);
    LCD_Reg_Set(0x007181, 24);
    Wait(3 * 1200);
    LCD_Reg_Set(0x000D20, 24);
    LCD_Reg_Set(0x002E00, 24);
    LCD_Reg_Set(0x001100, 24);
    Wait(340 * 1200);
    LCD_Reg_Set(0x001200, 24);
    LCD_Reg_Set(0x008574, 24);
    LCD_Reg_Set(0x002137, 24);
    LCD_Reg_Set(0x002202, 24);
    LCD_Reg_Set(0x002324, 24);
    LCD_Reg_Set(0x002413, 24);
    LCD_Reg_Set(0x00250A, 24);
    LCD_Reg_Set(0x002682, 24);
    LCD_Reg_Set(0x002701, 24);
    LCD_Reg_Set(0x006F00, 24);
    LCD_Reg_Set(0x001E26, 24);
    LCD_Reg_Set(0x001F57, 24);

    LCD_Reg_Set(0x00300777, 32);
    LCD_Reg_Set(0x00310444, 32);
    LCD_Reg_Set(0x00320555, 32);
    LCD_Reg_Set(0x00330444, 32);
    LCD_Reg_Set(0x00340333, 32);
    LCD_Reg_Set(0x00350333, 32);
    LCD_Reg_Set(0x00360333, 32);
    LCD_Reg_Set(0x00370333, 32);
    LCD_Reg_Set(0x00380444, 32);
    LCD_Reg_Set(0x00390555, 32);
    LCD_Reg_Set(0x003A0666, 32);
    LCD_Reg_Set(0x003B0666, 32);
    LCD_Reg_Set(0x003C0777, 32);
    LCD_Reg_Set(0x003D0777, 32);
    LCD_Reg_Set(0x003E0777, 32);
    LCD_Reg_Set(0x003F0777, 32);
    LCD_Reg_Set(0x00400777, 32);
    LCD_Reg_Set(0x00410777, 32);
    LCD_Reg_Set(0x00420777, 32);
    LCD_Reg_Set(0x00430777, 32);
    LCD_Reg_Set(0x00440777, 32);
    LCD_Reg_Set(0x00450777, 32);
    LCD_Reg_Set(0x00460777, 32);
    LCD_Reg_Set(0x00470777, 32);
    LCD_Reg_Set(0x00480777, 32);
    LCD_Reg_Set(0x00490777, 32);
    LCD_Reg_Set(0x004A0777, 32);
    LCD_Reg_Set(0x004B0777, 32);
    LCD_Reg_Set(0x004C0777, 32);
    LCD_Reg_Set(0x004D0666, 32);
    LCD_Reg_Set(0x004E0666, 32);
    LCD_Reg_Set(0x004F0666, 32);

    LCD_Reg_Set(0x001400, 24);
    LCD_Reg_Set(0x000004, 24);
    LCD_Reg_Set(0x000108, 24);
    LCD_Reg_Set(0x000200, 24);
    LCD_Reg_Set(0x00030000, 32);
    LCD_Reg_Set(0x0004EF, 24);
    LCD_Reg_Set(0x0005013F, 32);
    LCD_Reg_Set(0x0006FF, 24);
    LCD_Reg_Set(0x000701FF, 32);
    LCD_Reg_Set(0x0008FF, 24);
    LCD_Reg_Set(0x000901FF, 32);
    LCD_Reg_Set(0x000A00, 24);
    LCD_Reg_Set(0x000B00, 24);
    LCD_Reg_Set(0x000C00, 24);
    LCD_Reg_Set(0x001400, 24);
    LCD_Reg_Set(0x00150000, 32);
    LCD_Reg_Set(0x00160000, 32);
    LCD_Reg_Set(0x001701FF, 32);
    LCD_Reg_Set(0x001801FF, 32);
    LCD_Reg_Set(0x001300, 24);
    LCD_Reg_Set(0x001901FF, 32);
    LCD_Reg_Set(0x001B01FF, 32);
    LCD_Reg_Set(0x001C01FF, 32);
    LCD_Reg_Set(0x001A01FF, 32);
    LCD_Reg_Set(0x001D0E, 24);
    LCD_Reg_Set(0x000D00, 24);
    Wait(4 * 1200);
    LCD_Reg_Set(0x00B001, 24);
    Wait(110 * 1200);
    LCD_Reg_Set(0x00B002, 24);
    LCD_Reg_Set(0x002E0E, 24);
    LCD_Reg_Set(0x001E26, 24);
    LCD_Reg_Set(0x001140, 24);
    LCD_Reg_Set(0x007542, 24);
    LCD_Reg_Set(0x007121, 24);
    Wait(180 * 1200);
    LCD_Reg_Set(0x0011C0, 24);
    Wait(400 * 1200);
    LCD_Reg_Set(0x007545, 24);
    LCD_Reg_Set(0x007121, 24);
    Wait(180 * 1200);
    LCD_Reg_Set(0x000D24, 24);
    Wait(200 * 1200);
    LCD_Reg_Set(0x001002, 24);
    Wait(26 * 1200);
}

// *************************FSMCiSRAMoNRgpj*******************************************
// RESET PB8, VSYNC PB0, VDEN PB6, VCLK PD5(invert)
// R5 PE7, R4 PD1, R3 PD0, R2 PD15, R1 PD14, R0 *
// G5 PE13, G4 PE12, G3 PE11, G2 PE10, G1 PE9, G0 PE8
// B5 PD10, B4 PD9, B3 PD8, B2 PE15, B1 PE14, B0 *
void FSMC_Init(void)
{   RCC->AHBENR|= 0x00000100;// clock for FSMC 0000 0001 0000 0000
    FSMC_Bank1->BTCR[FSMC_Bank1_NORSRAM3+1] =         // Bank1 NOR/SRAM timing register configuration
                                         (0 << 28) |  // FSMC AccessMode A
                                         (0 << 24) |  // Data Latency
                                         (0 << 20) |  // CLK Division
                                         (0 << 16) |  // Bus Turnaround Duration
                                         (7 <<  8) |  // Data SetUp Time
                                         (0 <<  4) |  // Address Hold Time
                                         (2 <<  0) ;  // Address SetUp Time
                                         
    FSMC_Bank1->BTCR[FSMC_Bank1_NORSRAM3  ] =         // Control register
                                         (0 << 19) |  // Write burst disabled
                                         (0 << 15) |  // Async wait disabled
                                         (0 << 14) |  // Extended mode disabled
                                         (0 << 13) |  // NWAIT signal is disabled
                                         (1 << 12) |  // Write operation enabled
                                         (0 << 11) |  // NWAIT signal is active one data cycle before wait state
                                         (0 << 10) |  // Wrapped burst mode disabled
                                         (0 <<  9) |  // Wait signal polarity active low
                                         (0 <<  8) |  // Burst access mode disabled
                                         (1 <<  4) |  // Memory data  bus width is 16 bits
                                         (0 <<  2) |  // Memory type is SRAM
                                         (0 <<  1) |  // Address/Data Multiplexing disable
                                         (1 <<  0) ;  // Memory Bank enable
}


//****************************RAM`̈ɂVZO\邽߂̏*****************************************
void SEG_CLR(void)//Clear Black
{   int i;
    for(i = 0; i < 80 * 240; i++)
    {   PIC3[i] = 0;
    }
}

void SEG_H(int x, int y, int c)
{   int i, PX;
    PX = y * 240 + x;
    for(i = 0; i < 32; i++)//L1
    {   PIC3[PX + 3 + i] = c;
    }
    for(i = 0; i < 34; i++)//L2
    {   PIC3[PX + 240 + 2 + i] = c;
    }
    for(i = 0; i < 36; i++)//L3
    {   PIC3[PX + 480 + 1 + i] = c;
    }
    for(i = 0; i < 38; i++)//L4
    {   PIC3[PX + 720 + i] = c;
    }
    for(i = 0; i < 36; i++)//L5
    {   PIC3[PX + 960 + 1 + i] = c;
    }
    for(i = 0; i < 34; i++)//L6
    {   PIC3[PX + 1200 + 2 + i] = c;
    }
    for(i = 0; i < 32; i++)//L7
    {   PIC3[PX + 1440 + 3 + i] = c;
    }
}

void SEG_V(int x, int y, int c)
{   int i, PX;
    PX = y * 240 + x;
    PIC3[PX + 5] = c;//L1
    for(i = 0; i < 3; i++)//L2
    {   PIC3[PX + 240 + 4 + i] = c;
    }
    for(i = 0; i < 5; i++)//L3
    {   PIC3[PX + 480 + 3 + i] = c;
    }
    for(i = 0; i < 7; i++)//L4-L27
    {   PIC3[PX + 720 + 2 + i] = c;
        PIC3[PX + 960 + 2 + i] = c;
        PIC3[PX + 1200 + 2 + i] = c;
        PIC3[PX + 1440 + 2 + i] = c;
        PIC3[PX + 1680 + 2 + i] = c;
        PIC3[PX + 1920 + 2 + i] = c;
        PIC3[PX + 2160 + 1 + i] = c;
        PIC3[PX + 2400 + 1 + i] = c;
        PIC3[PX + 2640 + 1 + i] = c;
        PIC3[PX + 2880 + 1 + i] = c;
        PIC3[PX + 3120 + 1 + i] = c;
        PIC3[PX + 3360 + 1 + i] = c;
        PIC3[PX + 3600 + 1 + i] = c;
        PIC3[PX + 3840 + 1 + i] = c;
        PIC3[PX + 4080 + 1 + i] = c;
        PIC3[PX + 4320 + 1 + i] = c;
        PIC3[PX + 4560 + 1 + i] = c;
        PIC3[PX + 4800 + 1 + i] = c;
        PIC3[PX + 5040 + i] = c;
        PIC3[PX + 5280 + i] = c;
        PIC3[PX + 5520 + i] = c;
        PIC3[PX + 5760 + i] = c;
        PIC3[PX + 6000 + i] = c;
        PIC3[PX + 6240 + i] = c;
    }
    for(i = 0; i < 5; i++)//L28
    {   PIC3[PX + 6480 + 1 + i] = c;
    }
    for(i = 0; i < 3; i++)//L29
    {   PIC3[PX + 6720 + 2 + i] = c;
    }
    PIC3[PX + 6960 + 3] = c;//L30
}

//7seg LED
//  a
//f   b
//  g
//e   c
//  d
//
void SEG7_Draw(int X, int Y, int C, int A)//WX,YCFClil͈̔͊O`FbN͂ĂȂ̂ŗvӁj
{   switch(A)
    {  case 0x00://0
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          //SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x01://1
          //SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          //SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x02://2
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          //SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x03://3
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x04://4
          //SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x05://5
          SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x06://6
          SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x07://7
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          //SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x08://8
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x09://9
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0A://A
          SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0B://b
          //SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0C://c
          //SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          //SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0D://d
          //SEG_H(X + 9, Y, C);//a
          SEG_V(X + 43, Y + 5, C);//b
          SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0E://E
          SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          //SEG_V(X + 41, Y + 40, C);//c
          SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x0F://F
          SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          //SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          SEG_V(X, Y + 40, C);//e
          SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      case 0x10://-
          //SEG_H(X + 9, Y, C);//a
          //SEG_V(X + 43, Y + 5, C);//b
          //SEG_V(X + 41, Y + 40, C);//c
          //SEG_H(X + 5, Y + 69, C);//d
          //SEG_V(X, Y + 40, C);//e
          //SEG_V(X + 2, Y + 5, C);//f
          SEG_H(X + 7, Y + 34, C);//g
          break;
      default: break;
    }
}

// ********************************CvO***********************************************
//̂قƂǂstm32_Init()ōsĂ
// SW1 = PB8
int main (void)
{   stm32_Init();
    GPIOD->BSRR = 0x00000010;//LED(PD4) ON 0000 0000 0001 0000(ON=LED OFF)
    DMA_IR_Init();
    FSMC_Init();
    SCS_Set(1);
    GLCD_Init();
    SEG_CLR();//炩7ZÕf[^RAM̈ɕ`Ăiʒu͕ςȂق悢j
    SEG7_Draw(6, 3, 0x001F, 2);
    SEG7_Draw(64, 3, 0x001F, 0);
    SEG7_Draw(122, 3, 0x001F, 1);
    SEG7_Draw(180, 3, 0x001F, 1);
    GPIOD->BSRR = 0x00100000;//LED(PD4) OFF 0000 0000 0001 0000(ON=LED OFF)
    T_Flag = 1;//^C}[ݗL
    while (1)
    {
    }
}
